import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {

        int n = nextInt();
        int m = nextInt();
        int cnt = 0;
        char[][] arr = new char[n][6];
        for (int i = 0; i < n; i++) {
            String ln = br.readLine();
            arr[i] = ln.toCharArray();
            for (int j = 0; j < 3; j++) {
                if ( arr[i][j] != arr[i][5-j] ) {
                    cnt++;
                    arr[i][j] = 'X';
                    arr[i][5-j] = 'X';
                }
                if ( cnt > m ) {
                    out.println("Impossible");
                    out.close();
                    return;
                }
            }
        }


        if ( (m-cnt) > 0 && (m-cnt) % 2 == 0 ) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < 3; j++) {
                    if ((m-cnt) > 0 && arr[i][j] == '.' && arr[i][5-j] == '.') {
                        cnt+=2;
                        arr[i][j] = 'X';
                        arr[i][5-j] = 'X';
                    }
                }
            }
        }


        if ( (m-cnt) > 0 ) {
            out.println("Impossible");
            out.close();
            return;
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 6; j++) {
                out.print(arr[i][j]);
            }
            out.println();
        }



        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}