import java.io.*;
import java.util.*;

public class Main {

    static boolean isBito(long[] arr, int l, int r) {
        int up = 0;
        int down = 0;
        boolean up2 = true;
        boolean down2 = true;
        for (int i = l+1; i < r; i++) {

            if ( arr[i] == arr[i-1] ) {
                return false;
            }

            if ( arr[i] > arr[i-1] && down == 0 ) {
                if ( down2 ) {
                    up++;
                }
                up2 = true;
                down2 = false;
            } else if ( arr[i] >= arr[i-1] && down > 0 ) {
                return false;
            }

            if ( arr[i] < arr[i-1] ) {
                if ( up2 ) {
                    down++;
                }
                up2 = false;
                down2 = true;
            }
        }
        if ( up == 1 && down == 1 || (up == 0 && down == 1) || (up == 1 && down == 0) || ( up == 0 && down == 0 ) ) {
            return true;
        } else {
            return false;
        }
    }

    public static void main(String[] args) throws IOException {

        int n = nextInt();
        long[] arr = new long[n];

        for (int i = 0; i < n; i++) {
            arr[i] = nextLong();
        }

        int cnt = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                if ( isBito(arr, i,j+1)) {
                    cnt++;
                }
            }
        }

        out.println(cnt);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}