import java.io.*;
import java.util.*;

public class Main {


    static boolean isEasy(double num) {
        int d = 2;
        if ( num == 1 ) return false;
        double sq = Math.sqrt(num);
        while ( d <= sq ) {
            if ( num % d == 0 ) {
                return false;
            }
            d++;
        }
        return true;
    }

    static boolean check (int num, long[] n, int cnt) {
        int ind = -1;
        Arrays.sort(n);
        for (int i = n.length-1; i >= n.length-cnt; i--) {
            long a = n[i];
            if ( Math.max(num,a) % Math.min(num,a) == 0 ) {
                ind = i;
                break;
            }
        }
        if ( ind != -1 && isEasy((double)Math.max(num,n[ind])/Math.min(num,n[ind])) ) {
            return false;
        }
        return true;
    }


    public static void main(String[] args) throws IOException {

        int n = nextInt();
        int[] arr = new int[n];
        long[] x = new long[n];
        long[] y = new long[n];
        int cnt1 = 0;
        int cnt2 = 0;

        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
            if ( cnt1 == 0 || check(arr[i], x, cnt1) ) {
                x[cnt1] = arr[i];
                arr[i] = 1;
                cnt1++;
            } else {
                y[cnt2] = arr[i];
                arr[i] = 2;
                cnt2++;
            }
        }


        for(int s: arr) {
            out.print(s + " ");
        }


        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}