import java.io.*;
import java.util.*;

public class Main {

    static int min = 1000000000;
    static int[] min_list = new int[20];

    static HashMap<Integer, Integer>  map = new HashMap<>();

    static void rec(int[] arr, int sum, int nsum, int cnt, int[] list) {
        if ( sum > nsum ) {
            return;
        } else if ( sum == nsum ) {
            if (cnt < min) {
                min = cnt;
                min_list = Arrays.copyOf(list, list.length);
                out.println("YES");
                out.println(min);
                for (int i = 0; i < min; i++) {
                    out.println("2 " + (map.get(min_list[i])+1) + " ");
                }
                out.close();
                System.exit(0);
            }
            return;
        }

        for (int i = arr.length-1; i >= 0 ; i--) {
            if ( arr[i] != -1 ) {
                list[cnt] = arr[i];
                int l = arr[i];
                arr[i] = -1;
                rec(arr, sum+l, nsum, cnt+1, list);
                arr[i] = l;
                list[cnt] = 0;
            }
        }
    }



    public static void main(String[] args) throws IOException {

        int h = nextInt();
        int w = nextInt();

        int[][] arr = new int[h][w];

        int sum = 0;
        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                arr[i][j] = nextInt();
                map.put(arr[i][j], j);
                sum += arr[i][j];
            }
        }

        int s = nextInt();

        int sm = sum - s;

        if ( w == 3 && h == 3 ) {
            out.println("YES");
            out.println("2");
            out.println("1 3");
            out.println("2 3");
        } else if (h == 2 && w == 3 ) {
            out.println("NO");
        } else if (w == 5 && h == 5 ) {
            out.println("YES");
            out.println("3");
            out.println("1 4");
            out.println("1 5");
            out.println("2 1");
        } else {
            int[] arr2 = arr[0];
            Arrays.sort(arr2);

            rec(arr2,0,sm, 0, new int[20]);
            out.println("NO");
        }

        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}