import java.io.*;
import java.util.*;

public class Main {


    static boolean isEasy(double num) {
        int d = 2;
        if ( num == 1 ) return false;
        double sq = Math.sqrt(num);
        while ( d <= sq ) {
            if ( num % d == 0 ) {
                return false;
            }
            d++;
        }
        return true;
    }

    static boolean check (int num, ArrayList<Integer> n, ArrayList<Long> prost) {
        int ind = 0;
        for (int i = 0; i < n.size(); i++) {
            int a = n.get(i);
            if ( Math.max(num,a) % Math.min(num,a) == 0 ) {
                if ( n.get(ind) < a ) {
                    ind = i;
                }
                break;
            }
        }
        int a = n.get(ind);
        if ( prost.contains((long)Math.max(num,a) / Math.min(num,a)) ) {
            return false;
        }
        return true;
    }


    public static void main(String[] args) throws IOException {

        int n = nextInt();
        int[] arr = new int[n];
        ArrayList<Integer> x = new ArrayList<>();
        ArrayList<Integer> y = new ArrayList<>();
        ArrayList<Long> prost = new ArrayList<>();

        for (long i = 2; i < 100; i++) {
            if ( isEasy(i) ) {
                prost.add(i);
            }
        }

        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
            if ( x.isEmpty() || check(arr[i], x, prost) ) {
                x.add(arr[i]);
                arr[i] = 1;
            } else {
                y.add(arr[i]);
                arr[i] = 2;
            }
        }


        for(int s: arr) {
            out.print(s + " ");
        }


        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}