import java.io.*;
import java.util.*;

public class Main {

    static long count( long time, long[] a, long[] t ) {
        long cnt = 0;
        long cup = 0;
        long active = 0;
        for (int i = 1; i <= time; i++) {
            active *= 2;
            for (int j = 0; j < a.length; j++) {
                if ( i == a[j] + t[j] ) {
                    cup--;
                    active+=2;
                }
                if ( i == a[j] ) {
                    cup++;
                }
            }
        }

        return active + cup;
    }

    public static void main(String[] args) throws IOException {

        int n = nextInt();
        long m = nextLong();

        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }

        long[] t = new long[n];
        for (int i = 0; i < n; i++) {
            t[i] = nextLong();
        }

        for (int i = 0; i < 50; i++) {
            long res = count(i, a, t);
            if ( res > m ) {
                out.println(-1);
                break;
            } else if ( res == m ) {
                out.println(i);
                out.close();
                return;
            }
        }


        out.println(-1);

//        13 124
//        5 6 8 8 1 6 4 6 4 7 10 3 9
//        5 2 10 5 2 1 1 4 8 3 4 1 9

        out.close();

    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}