import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {

        int n = nextInt();
        long[] arr = new long[n];
        long sum = 0;
        int max_i = 0;
        long max = 0;
        for (int i = 0; i < n; i++) {
            arr[i] = nextLong();
            if ( arr[i] > max ) {
                max = arr[i];
                max_i = i;
            }
            sum += arr[i];
        }

        long ost = sum % n;
        for (int i = 0; i < n; i++) {
            if ( ost == 0 ) {
                break;
            }
            if ( arr[i] > sum/n ) {
                if ( arr[i] - ost < sum/n ) {
                    arr[i] = sum / n;
                    ost = arr[i] - sum/n;
                } else {
                    arr[i] = arr[i] - ost;
                    ost = 0;
                }
            }
        }

        long cnt = 0;
        for (int i = 0; i < n; i++) {
            if ( arr[i] < sum/n ) cnt++;
        }

        out.println(sum%n + " " + cnt);



        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}