import java.io.*;
import java.util.*;

public class Main {

    static int k;

    static void rec( long l, long r, long[] arr, int ind, int cnt1, int cnt2, ArrayList<Long> left, ArrayList<Long> right, int prev ) {
        if ( l == r && ind == k ) {
            out.println(cnt1 + " " + cnt2);
            for (int i = 0; i < left.size(); i++) {
                out.print(left.get(i) + " ");
            }
            out.println();
            for (int i = 0; i < right.size(); i++) {
                out.print(right.get(i) + " ");
            }
            out.close();
            System.exit(0);
        } else if ( ind > k ){
            return;
        }

        for (int i = 0; i < 2; i++) {
            for (int j = prev+1; j < k; j++) {
                if ( arr[j] != -1 ) {
                    long h = arr[j];
                    arr[j] = -1;
                    if ( i == 0 ) {
                        left.add(h);
                        rec(l+h, r, arr, ind+1, cnt1 + 1, cnt2, left, right, j);
                        left.remove(h);
                    } else {
                        right.add(h);
                        rec(l, r+h, arr, ind+1, cnt1, cnt2+1, left, right, j);
                        right.remove(h);
                    }
                    arr[j] = h;
                }
            }
        }

    }


    public static void main(String[] args) throws IOException {

        k = nextInt();
        long n = nextLong();

        long sum = 0;
        long[] arr = new long[k+1];
        arr[0] = 1;
        long num = 2;
        sum += 1;
        for (int i = 1; i <= k; i++) {
            arr[i] = num;
            sum += arr[i];
            num *= 2;
        }

        if ( n > sum ) {
            out.println(-1);
            out.close();
            return;
        }

        rec(n, 0, arr, 0, 0, 0, new ArrayList<>(), new ArrayList<>(), 0);

        out.println(-1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}