import java.io.*;
import java.util.*;

public class Main {

    static int k;

    static void rec( long l, long r, long num, int ind, int cnt1, int cnt2, ArrayList<Long> left, ArrayList<Long> right ) {
        if ( l == r && ind == k ) {
            out.println(cnt1 + " " + cnt2);
            for (int i = 0; i < left.size(); i++) {
                out.print(left.get(i) + " ");
            }
            out.println();
            for (int i = 0; i < right.size(); i++) {
                out.print(right.get(i) + " ");
            }
            out.close();
            System.exit(0);
        } else if ( ind >= k ) {
            return;
        }

        for (int i = 0; i < 2; i++) {
            long h = num;
            if ( i == 0 ) {
                left.add(h);
                rec(l+h, r, num*2, ind+1, cnt1 + 1, cnt2, left, right);
                left.remove(h);
            } else {
                right.add(h);
                rec(l, r+h, num*2, ind+1, cnt1, cnt2+1, left, right);
                right.remove(h);
            }

        }

    }


    public static void main(String[] args) throws IOException {

        k = nextInt();
        long n = nextLong();

        rec(n, 0, 1, 0, 0, 0, new ArrayList<>(), new ArrayList<>());

        out.println(-1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}