import java.io.*;
import java.util.*;

public class Main {

    static int k;

    static void rec( long l, long r, long num, int ind, int cnt1, int cnt2, long[] left, long[] right ) {
        if ( l == r && ind == k ) {
            out.println(cnt1 + " " + cnt2);
            for (int i = 0; i < cnt1; i++) {
                out.print(left[i] + " ");
            }
            out.println();
            for (int i = 0; i < cnt2; i++) {
                out.print(right[i] + " ");
            }
            out.close();
            System.exit(0);
        } else if ( ind >= k ) {
            return;
        }

        for (int i = 0; i < 2; i++) {
            if ( i == 0 ) {
                left[cnt1] = num;
                rec(l+num, r, num*2, ind+1, cnt1 + 1, cnt2, left, right);
                left[cnt1] = 0;
            } else {
                right[cnt2] = num;
                rec(l, r+num, num*2, ind+1, cnt1, cnt2+1, left, right);
                right[cnt2] = 0;
            }

        }

    }


    public static void main(String[] args) throws IOException {

        k = nextInt();
        long n = nextLong();

        rec(n, 0, 1, 0, 0, 0, new long[k], new long[k]);

        out.println(-1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}